<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Graham Featherstone - Project 11</title>
    <link href="../../styles.css" rel="stylesheet" />
</head>

<body>
    <header>
        <div class="container">
            <div class="text-container">
                <h1>Graham Featherstone</h1>
                <p>Chemical Engineering Student | Teacher | Enthusiast</p>
            </div>
            <img src="../../Cropped2.jpg" width="200px">
        </div>
    </header>

    <section>
        <h1>Project 11</h1>
        <h2>
            Key Objectives
        </h2>
        <hl>
            <li>Output Devices</li>
            <li>Further utilize KiCad</li>
            <li>Learn skills towards my final project</li>
        </hl>
    </section>

    <section>
        <h1>
            Output devices and KiCad
        </h1>
        <p>
            This week, the objective was to design a circuit that can control a more complex output device such as a
            motor, or a speaker rather than a simple LED. This task seemed extremely daunting once I began looking for
            help on YouTube and other websites. What is
            the difference between a brushed and brushless motor? Where do stepper motors come in? Is a stepper motor a
            brushless motor? How do we control these different types of motors? Is motor control performed by the
            microcontoller or another device? What is the function
            of a motor driver and why can't the controller perform the same function? SO MANY QUESTIONS, SO LITTLE TIME.
        </p>
        <p>
            At first, I thought that I was going to be using a stepper motor. I had chosen a stepper motor for the
            precise speed and directional control that they provide. I designed all of the circuits, the PCB "rats
            nest", and then finally came to the lab to construct the board...
            that is when I ran into an issue... The motor drivers for stepper motors that we have available are
            extremely small pieces of equipment, well above my soldering experience level. At this point, I had to go
            back to the very beginning and re-think my pcb design to fit within my current
            skill level. First, I selected ALL of the motordrivers, stepped, brushed, and brushless and placed them on
            my KiCad schematic editor. This gave me a good indication of the size and complexity of each of the devices.
            It seemed that the stepper motor drivers were highly complex as a stepper motor
            requires two circuits to precisely control the motor rotation, as well as having multiple sensors and built
            in functionality such as mode selection and sleep mode which should could be very useful for a complex
            system, but that is quite out of the scope of my first output device project.
        </p>
        <div class="image-container">
            <img src="Project11Images/Capture6.jpg" width="500px">
            <img src="Project11Images/Capture7.jpg" width="500px">
        </div>
        <div class="image-container">
            <img src="Project11Images/Capture8.jpg" width="500px">
        </div>
        <p>
            I decided on the A4953, the Toshiba TB67, or the TI DRV883x motordriver. When I pitched my dilemma to the
            lab manager, he suggested that I first try the Toshiba TB67. The image below to the left is the original
            placement of the parts that I knew that I wanted to include in the final design, and the image on the below
            right is the final design that I decided on. This is where
            I originally ran into many issues. While reading the data sheets for the different devices, I quickly felt
            overwhelmed by the amount of information and terminology that I did not understand. As an example, what role
            do the capacitors above the motordriver play (2x)?
            This is where I began to fall down the rabbit hole, where I started watching videos about how capacitors
            function, and the role of capacitors in circuits. This additional research unfortunately took a lot of time
            and delayed my completion of the project. Additionally, the frustration
            of not understanding played a role in the delay. There were several days where I had to leave and return
            once I was more level headed. Luckily, the lab supervisor informed me that much of this information had been
            covered in the previous weeks lecture which I had missed due to my CNC milling project.
            I decided to watch the video, follow along, and hope that it will make sense with all of the additional
            reading that I had already completed. It did! Below are images of my final circuits and PCB design (solved
            rats nest), along with connection ports along the edges of the PCB.
        </p>
        <div class="image-container">
            <img src="Project11Images/Capture1.JPG" width="500px">
            <img src="Project11Images/Capture4.JPG" width="500px">
        </div>
        <div class="image-container">
            <img src="Project11Images/Capture2.JPG" width="500px">
            <img src="Project11Images/Capture3.JPG" width="500px">
        </div>
        <p>
            After this, everything else was rather strait forward. The identical issue occurred again when exporting the
            design from KiCad to a Gerber file, so I set the borders around my design manually.
            After this was done, everything went smoothly and the board milled very well on the first try! The drill
            holes worked out well, and the depth was correct. The only issue that I had to troubleshoot was that the
            board was not completely flat so there were some
            areas where the board was milled quite deep, while others where the milling bit barely touched the surface.
            I then increased the z-axis zero to slightly below the surface of the board and re-milled it. This solved
            the issue.
        </p>
        <div class="image-container">
            <img src="Project11Images/Capture9.jpg" width="500px">
        </div>
        <h1> Populating the board</h1>
        <p>This step was rather strait forward as we have populated several boards before. The only issue was concerning
            the bottom pad that needed the be soldered for the motor driver, and the directional capacitor that was
            included
            on this board (large silver one on image below). The issue with the directional capacitor was the direction
            of the current flow and which side was positive and which was negative. Again, I have several issues with
            understanding that the
            side where electrons build up is positive, and where they are discharged is negative. But this is just from
            my chemical perspective and I understand it changes between electrolytic and voltaic cells; so chemist have
            their own issues to deal with. But I researched the
            capacitor on its data sheet and discovered that the side of the capacitor with the red line (or thick black
            line in some cases) is the negative terminal. The opposite side is the positive terminal.
        </p>
        <div class="image-container">
            <img src="Project11Images/Capture10.jpg" width="500px">
        </div>
        <p> Once the board was populated, I started testing all of the circuits and this is where I ran into one issue
            that I had not seen before. Like I said in Project 10, I notice one small error that I need to think about
            for every project in the future....THE WIDTH
            OF THE TREAD PATHS. While designing this model in KiCad, I had accidentally left the tread paths as 0.2mm,
            where they should be set to 0.4mm. I noticed this before milling the board but there is no universal way to
            convert all of the tread paths that I had already placed.
            In this case, I needed to individually click on each tread path and modify the width to be 0.4mm. I did this
            for the entire board...except for one... I only noticed this once I had completely populated the board, and
            I am going to have to complete the circuit by
            soldering a wire over the missing tread path. I am sure that 0.2mm might have also worked, but since I
            lowered the z-axis depth, I think that this destroyed the nice 0.2mm path. However, all other circuits
            tested well and I think that the board is ready to go!
        </p>
        <div class="image-container">
            <img src="Project11Images/Capture11.jpg" width="500px">
            <img src="Project11Images/Capture12.jpg" width="500px">
        </div>
        <p>Here is a picture of the track that I forgot to set as 0.4mm...(below)</p>
        <div class="image-container">
            <img src="Project11Images/Capture13.jpg" width="500px">
        </div>

        <h1>Programming and testing the board</h1>

        <p>To repair the milling error that I made, I used a wire with two exposed copper ends to repair the missing
            tread. This was further optimized later. Programming the ATtiny412 using the UPDI programmer went rather
            well
            and I was able to quickly toggle the LED on and off, and use the button to control the LED.
        </p>
        <div class="image-container">
            <img src="Project11Images/Capture14.jpg" width="500px">
            <img src="Project11Images/Capture15.jpg" width="500px">
        </div>
        <video width="320" height="240" controls>
            <source src="Project11IMages/Video1.mp4" type="video/mp4">
        </video>
        <p> After checking that the LED functions, and that the button functions, it was time to try working with a
            motor and seeing if I can connect and properly use the motor controller with a 12V power supply.

        </p>

        <h1>12 V power supply</h1>
        <p>
            Now that the functionality and the programming of the ATtiny412 has successfully be completed, it is time to
            see if I am able to control the motor driver using the ATtiny412. To do this, I uploaded code to the
            ATtiny412 that should make the motor move forward, pause, move in reverse, and pause again. I also
            programmed the LED to flash when the signal was being sent to the motor driver so that I can time whether
            everything is functioning
            properly.
        </p>
        <div class="image-container">
            <img src="Project11Images/Spin.JPG" width="500px">
        </div>
        <p> The code above makes the button and the LED lights work together. The code below flashes the LED lights when
            the signal is being sent to the motor driver to control the motor direction.</p>
        <div class="image-container">
            <img src="Project11Images/Spin2.JPG" width="500px">
        </div>
        <p> Uploading the code to the ATtiny412 worked perfect the first time and it is was now time to test my design
            to see if the motor worked!</p>
        <center>
            <video width="400" height="400" controls>
                <source src="Project11Images/Video2.mp4" type="video/mp4">
            </video>
        </center>
        <p>
            Unfortunately, my design did not work... As you can see in the above video, I can supply 12V to the board
            and the LED still functions, but the motor does not spin... I tested the board by supplying each individual
            component with the required voltage, but unfortunately screwed up
            by supplying the UPDI pin on the ATtiny with voltage...the chip became unresponsive after this...
        </p>
        <div class="image-container">
            <img src="Project11Images/Capture18.jpg" width="500px">
        </div>
        <p> To troubleshoot this, I needed to desolder the old ATtiny chip, and resolder a new one...</p>
        <div class="image-container">
            <img src="Project11Images/Capture16.jpg" width="500px">
        </div>
        <p> Once it was resoldered and completed, it looked like the image below</p>
        <div class="image-container">
            <img src="Project11Images/Capture17.jpg" style="transform:rotate(-90deg);width:500px">
        </div>
        <p> Even with everything replaced, the code re-uploaded... I could NOT get the motor to work! Through several
            hours of trouble shooting and asking the teacher to help me out, we finally pinpointed my design error... I
            have made an island of the resistor
            which did not allow it to be grounded with the rest of the board...highlighted in the next image.
        </p>
        <div class="image-container">
            <img src="Project11Images/Capture17a.jpg" style="width:500px">
        </div>
        <p> Through adding a jumper wire between this resistors ground and the PWR_GND of the rest of the board.. I was
            able to finally get the motor spinning!</p>
        <center>
            <video width="400" height="400" controls>
                <source src="Project11Images/Video3.mp4" type="video/mp4">
            </video>
        </center>
    </section>




</body>

</html>